int buzzer = 13;                              // le buzzer est alimenté par la borne 13
int trig = 9;                                 // l'émission est pilotée par la borne 9
int echo = 8;                                 // la réception des US est connectée à la borne 8
long duree;                                   // création d'une variable qui stocke la durée de l'aller-retour
float distance;                               // création d'une variable qui stocke la valeur de la distance en cm

void setup(){
    Serial.begin(9600);
    pinMode(trig, OUTPUT);                    // trig (qui alimente l'émetteur) est déclaré comme une sortie
    pinMode(echo, INPUT);                     // echo est déclaré comme une entrée
    pinMode(buzzer, OUTPUT);                      // la borne 13 est déclarée comme une sortie
}

void piezo (long dis){
// Ci dessous : la fonction qui détermine s'il faut alimenter le buzzer
  if(dis <= 20 && dis > 0){ // si la distance est inférieure à 20cm, exécute les instructions...
    tone(buzzer, 1000);     // alimente le buzzer avec une tension sinusoïdale de fréquence 1000Hz
  }
  else {                    // sinon...
    noTone(buzzer);         // éteint le buzzer
  }
}

void loop() {
    digitalWrite(trig, LOW);        // pas d'ultrason
    delayMicroseconds(2);           // attend 2 ms
    digitalWrite(trig, HIGH);       // émet une salve d'ultrasons
    delayMicroseconds(500);         // attend 500 µs
    digitalWrite(trig, LOW);        // arrête les US
    duree = pulseIn(echo, HIGH);    // 'duree' est la durée écoulée entre émission et réception d'une salve
    distance = duree / 58;          // calcul de la distance
    Serial.print("Distance : ");    // écrit le mot "Distance : "
    Serial.print(distance);         // écrit la valeur de la distance 
    Serial.println("cm");           // écrit "cm"
    piezo(distance);                // appelle la fonction piezo pour déterminer s'il faut alimenter le buzzer
}
